<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:24 CEST 2019 -->
<title>DatatypeCoder.RawDateTimeStruct (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DatatypeCoder.RawDateTimeStruct (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.html" title="interface in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/DefaultDatatypeCoder.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html" target="_top">Frames</a></li>
<li><a href="DatatypeCoder.RawDateTimeStruct.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng</div>
<h2 title="Class DatatypeCoder.RawDateTimeStruct" class="title">Class DatatypeCoder.RawDateTimeStruct</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.firebirdsql.gds.ng.DatatypeCoder.RawDateTimeStruct</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>Enclosing interface:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.html" title="interface in org.firebirdsql.gds.ng">DatatypeCoder</a></dd>
</dl>
<hr>
<br>
<pre>public static final class <span class="typeNameLabel">DatatypeCoder.RawDateTimeStruct</span>
extends <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></pre>
<div class="block">Raw date/time value.
 <p>
 Fractions are sub-second precision in 100 microseconds.
 </p>
 <p>
 We cannot simply pass millis to the database, because Firebird stores timestamp in format (citing Ann W.
 Harrison):
 </p>
 <p>
 "[timestamp is] stored a two long words, one representing the number of days since 17 Nov 1858 and one
 representing number of 100 nano-seconds since midnight" (NOTE: It is actually 100 microseconds!)
 </p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#day">day</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#fractions">fractions</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#hour">hour</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#minute">minute</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#month">month</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#second">second</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#year">year</a></span></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#RawDateTimeStruct--">RawDateTimeStruct</a></span>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#RawDateTimeStruct-org.firebirdsql.gds.ng.DatatypeCoder.RawDateTimeStruct-">RawDateTimeStruct</a></span>(<a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html" title="class in org.firebirdsql.gds.ng">DatatypeCoder.RawDateTimeStruct</a>&nbsp;raw)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#RawDateTimeStruct-int-boolean-int-boolean-">RawDateTimeStruct</a></span>(int&nbsp;encodedDate,
                 boolean&nbsp;hasDate,
                 int&nbsp;encodedTime,
                 boolean&nbsp;hasTime)</code>
<div class="block">Initializes a raw date/time value from encoded time and/or date integers.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#getEncodedDate--">getEncodedDate</a></span>()</code>
<div class="block">Encodes the date as used by Firebird (Modified Julian Date, or number of days since 17 November 1858).</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#getEncodedTime--">getEncodedTime</a></span>()</code>
<div class="block">Encodes the time as used by Firebird (fractions (100 milliseconds) in a day).</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#getFractionsAsNanos--">getFractionsAsNanos</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html#setFractionsFromNanos-long-">setFractionsFromNanos</a></span>(long&nbsp;nanos)</code>
<div class="block">Sets the sub-second fraction (100 microseconds) from a nanosecond value.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="year">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>year</h4>
<pre>public&nbsp;int year</pre>
</li>
</ul>
<a name="month">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>month</h4>
<pre>public&nbsp;int month</pre>
</li>
</ul>
<a name="day">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>day</h4>
<pre>public&nbsp;int day</pre>
</li>
</ul>
<a name="hour">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hour</h4>
<pre>public&nbsp;int hour</pre>
</li>
</ul>
<a name="minute">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>minute</h4>
<pre>public&nbsp;int minute</pre>
</li>
</ul>
<a name="second">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>second</h4>
<pre>public&nbsp;int second</pre>
</li>
</ul>
<a name="fractions">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>fractions</h4>
<pre>public&nbsp;int fractions</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="RawDateTimeStruct--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>RawDateTimeStruct</h4>
<pre>public&nbsp;RawDateTimeStruct()</pre>
</li>
</ul>
<a name="RawDateTimeStruct-int-boolean-int-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>RawDateTimeStruct</h4>
<pre>public&nbsp;RawDateTimeStruct(int&nbsp;encodedDate,
                         boolean&nbsp;hasDate,
                         int&nbsp;encodedTime,
                         boolean&nbsp;hasTime)</pre>
<div class="block">Initializes a raw date/time value from encoded time and/or date integers.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>encodedDate</code> - Encoded date (Modified Julian Date)</dd>
<dd><code>hasDate</code> - If date should be decoded (set <code>false</code> for a time-only value)</dd>
<dd><code>encodedTime</code> - Encoded time (fractions in day)</dd>
<dd><code>hasTime</code> - If time should be decoded (set <code>false</code> for a date-only value)</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>4.0</dd>
</dl>
</li>
</ul>
<a name="RawDateTimeStruct-org.firebirdsql.gds.ng.DatatypeCoder.RawDateTimeStruct-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>RawDateTimeStruct</h4>
<pre>public&nbsp;RawDateTimeStruct(<a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html" title="class in org.firebirdsql.gds.ng">DatatypeCoder.RawDateTimeStruct</a>&nbsp;raw)</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getFractionsAsNanos--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFractionsAsNanos</h4>
<pre>public&nbsp;int&nbsp;getFractionsAsNanos()</pre>
</li>
</ul>
<a name="setFractionsFromNanos-long-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setFractionsFromNanos</h4>
<pre>public&nbsp;void&nbsp;setFractionsFromNanos(long&nbsp;nanos)</pre>
<div class="block">Sets the sub-second fraction (100 microseconds) from a nanosecond value.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>nanos</code> - Sub-second nanoseconds</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>4.0</dd>
</dl>
</li>
</ul>
<a name="getEncodedDate--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEncodedDate</h4>
<pre>public&nbsp;int&nbsp;getEncodedDate()</pre>
<div class="block">Encodes the date as used by Firebird (Modified Julian Date, or number of days since 17 November 1858).</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Encoded date</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>4.0</dd>
</dl>
</li>
</ul>
<a name="getEncodedTime--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getEncodedTime</h4>
<pre>public&nbsp;int&nbsp;getEncodedTime()</pre>
<div class="block">Encodes the time as used by Firebird (fractions (100 milliseconds) in a day).</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Encoded time</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>4.0</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/DatatypeCoder.html" title="interface in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/DefaultDatatypeCoder.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/DatatypeCoder.RawDateTimeStruct.html" target="_top">Frames</a></li>
<li><a href="DatatypeCoder.RawDateTimeStruct.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
